(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@swimlane/ngx-charts'), require('d3-shape'), require('d3-scale'), require('@angular/animations'), require('@angular/common'), require('@swimlane/ngx-graph')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@swimlane/ngx-charts', 'd3-shape', 'd3-scale', '@angular/animations', '@angular/common', '@swimlane/ngx-graph'], factory) :
	(factory((global['neu-charts'] = {}),global.ng.core,global.ngxCharts,global.d3Shape,global.d3Scale,global.ng.animations,global.ng.common,global.ngxGraph));
}(this, (function (exports,core,ngxCharts,d3Shape,d3Scale,animations,common,ngxGraph) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}








function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}
function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var NeuChartsComponent = /** @class */ (function () {
    function NeuChartsComponent() {
    }
    NeuChartsComponent.prototype.ngOnInit = function () { };
    return NeuChartsComponent;
}());
NeuChartsComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts',
                template: "<h3>Neu-charts works!</h3>\n",
                styles: [""]
            },] },
];
NeuChartsComponent.ctorParameters = function () { return []; };
var Options = /** @class */ (function () {
    function Options(showLegend) {
        if (showLegend === void 0) { showLegend = true; }
        this.showLegend = showLegend;
    }
    return Options;
}());
var PieOptions = /** @class */ (function (_super) {
    __extends(PieOptions, _super);
    function PieOptions(showLegend, showLabels, explodeSlices) {
        if (showLegend === void 0) { showLegend = true; }
        if (showLabels === void 0) { showLabels = true; }
        if (explodeSlices === void 0) { explodeSlices = false; }
        var _this = _super.call(this, showLegend) || this;
        _this.showLabels = showLabels;
        _this.explodeSlices = explodeSlices;
        _this.doughnut = false;
        return _this;
    }
    return PieOptions;
}(Options));
var customColorSets = [
    {
        name: 'palatte',
        domain: ['#9896F8', '#55efc4', '#76B3F9', '#81DD98', '#b867d3', '#f26f96', '#ffeaa7', '#FDBD2D', '#FC8A25', '#4d488c', '#FA4F1E', '#BDC3C7']
    }
];
var PieChartComponent = /** @class */ (function () {
    function PieChartComponent() {
        this.data = [];
        this.onSelect = new core.EventEmitter();
        this.options = new PieOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    PieChartComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    PieChartComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return PieChartComponent;
}());
PieChartComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-pie',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-pie-chart\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [explodeSlices]=\"options.explodeSlices\"\n        [labels]=\"options.showLabels\"\n        [doughnut]=\"options.doughnut\"\n        [gradient]=\"gradient\"\n        (select)=\"mSelectedEvent($event)\">\n        </ngx-charts-pie-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
PieChartComponent.ctorParameters = function () { return []; };
PieChartComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var DonutOptions = /** @class */ (function (_super) {
    __extends(DonutOptions, _super);
    function DonutOptions(showLegend, showLabels, arcWidth) {
        if (showLegend === void 0) { showLegend = true; }
        if (showLabels === void 0) { showLabels = true; }
        if (arcWidth === void 0) { arcWidth = 0.3; }
        var _this = _super.call(this, showLegend, showLabels, false) || this;
        _this.doughnut = true;
        _this.arcWidth = arcWidth;
        return _this;
    }
    return DonutOptions;
}(PieOptions));
var DonutChartComponent = /** @class */ (function () {
    function DonutChartComponent() {
        this.data = [];
        this.onSelect = new core.EventEmitter();
        this.options = new DonutOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    DonutChartComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.cutomOptions);
    };
    DonutChartComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return DonutChartComponent;
}());
DonutChartComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-donut',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-pie-chart\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [explodeSlices]=\"options.explodeSlices\"\n        [labels]=\"options.showLabels\"\n        [doughnut]=\"options.doughnut\"\n        [arcWidth]=\"options.arcWidth\"\n        [gradient]=\"gradient\"\n        (select)=\"mSelectedEvent($event)\">\n        </ngx-charts-pie-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
DonutChartComponent.ctorParameters = function () { return []; };
DonutChartComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "cutomOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var NoDataComponent = /** @class */ (function () {
    function NoDataComponent() {
    }
    NoDataComponent.prototype.ngOnInit = function () { };
    return NoDataComponent;
}());
NoDataComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'no-data',
                template: "<div class=\"no-data-container\">No data found (or) Wrong data format</div>",
                styles: ["\n    .no-data-container {\n        width: 100%;\n        height: 100%;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        color: lightslategray;\n        font-size: 1.2rem;\n    }"]
            },] },
];
NoDataComponent.ctorParameters = function () { return []; };
var DonutAdvancedComponent = /** @class */ (function () {
    function DonutAdvancedComponent() {
        this.data = [];
        this.onSelect = new core.EventEmitter();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    DonutAdvancedComponent.prototype.ngOnInit = function () { };
    DonutAdvancedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return DonutAdvancedComponent;
}());
DonutAdvancedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-donut-advanced',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-advanced-pie-chart\n        [view]=\"view\"\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [gradient]=\"gradient\"\n        (select)=\"mSelectedEvent($event)\">\n        </ngx-charts-advanced-pie-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}.chart-container /deep/ .total-value{font-size:1.4rem}.chart-container /deep/ .total-label{font-size:1.2rem}.chart-container /deep/ .legend-items{padding-top:10px}.chart-container /deep/ .legend-items .legend-item{line-height:1.4}.chart-container /deep/ .legend-items .legend-item:hover{opacity:.75}.chart-container /deep/ .legend-items .legend-item .item-value{font-size:1.2rem!important}.chart-container /deep/ .legend-items .legend-item .item-percent{font-size:1.1rem!important}"]
            },] },
];
DonutAdvancedComponent.ctorParameters = function () { return []; };
DonutAdvancedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "onSelect": [{ type: core.Output },],
};
var DonutGridComponent = /** @class */ (function () {
    function DonutGridComponent() {
        this.data = [];
        this.onSelect = new core.EventEmitter();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    DonutGridComponent.prototype.ngOnInit = function () { };
    DonutGridComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return DonutGridComponent;
}());
DonutGridComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-donut-grid',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-pie-grid\n      [view]=\"view\"\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-pie-grid>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
DonutGridComponent.ctorParameters = function () { return []; };
DonutGridComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "onSelect": [{ type: core.Output },],
};
var BarOptions = /** @class */ (function (_super) {
    __extends(BarOptions, _super);
    function BarOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = ''; }
        if (yAxisLabel === void 0) { yAxisLabel = ''; }
        var _this = _super.call(this, showLegend) || this;
        _this.showXAxis = showXAxis;
        _this.showYAxis = showYAxis;
        _this.showXAxisLabel = showXAxisLabel;
        _this.showYAxisLabel = showYAxisLabel;
        _this.xAxisLabel = xAxisLabel.toUpperCase();
        _this.yAxisLabel = yAxisLabel.toUpperCase();
        _this.barPadding = 3;
        return _this;
    }
    return BarOptions;
}(Options));
var BarVerticalComponent = /** @class */ (function () {
    function BarVerticalComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarVerticalComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarVerticalComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarVerticalComponent;
}());
BarVerticalComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-vertical',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-vertical\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-vertical>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarVerticalComponent.ctorParameters = function () { return []; };
BarVerticalComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarHorizontalComponent = /** @class */ (function () {
    function BarHorizontalComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarHorizontalComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarHorizontalComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarHorizontalComponent;
}());
BarHorizontalComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-horizontal',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-horizontal\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-horizontal>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarHorizontalComponent.ctorParameters = function () { return []; };
BarHorizontalComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarGroupedOptions = /** @class */ (function (_super) {
    __extends(BarGroupedOptions, _super);
    function BarGroupedOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = ''; }
        if (yAxisLabel === void 0) { yAxisLabel = ''; }
        var _this = _super.call(this, showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) || this;
        _this.groupPadding = 6;
        return _this;
    }
    return BarGroupedOptions;
}(BarOptions));
var BarVerticalGroupedComponent = /** @class */ (function () {
    function BarVerticalGroupedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarGroupedOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarVerticalGroupedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarVerticalGroupedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarVerticalGroupedComponent;
}());
BarVerticalGroupedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-vertical-grouped',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-vertical-2d\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      [groupPadding]=\"options.groupPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-vertical-2d>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarVerticalGroupedComponent.ctorParameters = function () { return []; };
BarVerticalGroupedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarHorizontalGroupedComponent = /** @class */ (function () {
    function BarHorizontalGroupedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarGroupedOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarHorizontalGroupedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarHorizontalGroupedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarHorizontalGroupedComponent;
}());
BarHorizontalGroupedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-horizontal-grouped',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-horizontal-2d\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      [groupPadding]=\"options.groupPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-horizontal-2d>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarHorizontalGroupedComponent.ctorParameters = function () { return []; };
BarHorizontalGroupedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarHorizontalStackedComponent = /** @class */ (function () {
    function BarHorizontalStackedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarHorizontalStackedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarHorizontalStackedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarHorizontalStackedComponent;
}());
BarHorizontalStackedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-horizontal-stacked',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-horizontal-stacked\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-horizontal-stacked>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarHorizontalStackedComponent.ctorParameters = function () { return []; };
BarHorizontalStackedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarVerticalStackedComponent = /** @class */ (function () {
    function BarVerticalStackedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarVerticalStackedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarVerticalStackedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarVerticalStackedComponent;
}());
BarVerticalStackedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-vertical-stacked',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-vertical-stacked\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-vertical-stacked>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarVerticalStackedComponent.ctorParameters = function () { return []; };
BarVerticalStackedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarVerticalNormalizedComponent = /** @class */ (function () {
    function BarVerticalNormalizedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarVerticalNormalizedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarVerticalNormalizedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarVerticalNormalizedComponent;
}());
BarVerticalNormalizedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-vertical-normalized',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-vertical-normalized\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-vertical-normalized>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarVerticalNormalizedComponent.ctorParameters = function () { return []; };
BarVerticalNormalizedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarHorizontalNormalizedComponent = /** @class */ (function () {
    function BarHorizontalNormalizedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new BarOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarHorizontalNormalizedComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    BarHorizontalNormalizedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BarHorizontalNormalizedComponent;
}());
BarHorizontalNormalizedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bar-horizontal-normalized',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bar-horizontal-normalized\n      [scheme]=\"colorScheme\"\n      [results]=\"data\"\n      [gradient]=\"gradient\"\n      [xAxis]=\"options.showXAxis\"\n      [yAxis]=\"options.showYAxis\"\n      [legend]=\"options.showLegend\"\n      [showXAxisLabel]=\"options.showXAxisLabel\"\n      [showYAxisLabel]=\"options.showYAxisLabel\"\n      [xAxisLabel]=\"options.xAxisLabel\"\n      [yAxisLabel]=\"options.yAxisLabel\"\n      [barPadding]=\"options.barPadding\"\n      (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bar-horizontal-normalized>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
BarHorizontalNormalizedComponent.ctorParameters = function () { return []; };
BarHorizontalNormalizedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var LineOptions = /** @class */ (function (_super) {
    __extends(LineOptions, _super);
    function LineOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel, timeline, isXAxisDate, referenceLines) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = ''; }
        if (yAxisLabel === void 0) { yAxisLabel = ''; }
        if (timeline === void 0) { timeline = false; }
        if (isXAxisDate === void 0) { isXAxisDate = false; }
        if (referenceLines === void 0) { referenceLines = []; }
        var _this = _super.call(this, showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) || this;
        _this.autoScale = true;
        _this.roundDomains = true;
        _this.timeline = timeline;
        _this.isXAxisDate = isXAxisDate;
        if (referenceLines.length == 0) {
            _this.showRefLines = true;
        }
        _this.referenceLines = referenceLines;
        return _this;
    }
    return LineOptions;
}(BarOptions));
var LineComponent = /** @class */ (function () {
    function LineComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new LineOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    LineComponent.prototype.ngOnInit = function () { };
    LineComponent.prototype.ngOnChanges = function (changes) {
        Object.assign(this.options, this.customOptions);
        if ((this.data && (changes["data"].previousValue != changes["data"].currentValue)) ||
            (this.options.isXAxisDate && (changes["customOptions"].previousValue != changes["customOptions"].currentValue))) {
            this.data.forEach(function (element) {
                element.series.forEach(function (seriesData) {
                    seriesData.name = new Date(seriesData.name);
                });
            });
        }
    };
    LineComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return LineComponent;
}());
LineComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-line',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-line-chart\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [autoScale]=\"options.autoScale\"\n        [roundDomains]=\"options.roundDomains\"\n        [timeline]=\"options.timeline\"\n        (select)=\"mSelectedEvent($event)\"\n        [showRefLines]=\"options.showRefLines\"\n        [referenceLines]=\"options.referenceLines\">\n    </ngx-charts-line-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
LineComponent.ctorParameters = function () { return []; };
LineComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var AreaComponent = /** @class */ (function () {
    function AreaComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new LineOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    AreaComponent.prototype.ngOnInit = function () { };
    AreaComponent.prototype.ngOnChanges = function (changes) {
        Object.assign(this.options, this.customOptions);
        if ((this.data && (changes["data"].previousValue != changes["data"].currentValue)) ||
            (this.options.isXAxisDate && (changes["customOptions"].previousValue != changes["customOptions"].currentValue))) {
            this.data.forEach(function (element) {
                element.series.forEach(function (seriesData) {
                    seriesData.name = new Date(seriesData.name);
                });
            });
        }
    };
    AreaComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return AreaComponent;
}());
AreaComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-area',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-area-chart\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [autoScale]=\"options.autoScale\"\n        [timeline]=\"options.timeline\"\n        (select)=\"mSelectedEvent($event)\">\n        <!-- [roundDomains]=\"options.roundDomains\"> -->\n    </ngx-charts-area-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
AreaComponent.ctorParameters = function () { return []; };
AreaComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var AreaStackedComponent = /** @class */ (function () {
    function AreaStackedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new LineOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    AreaStackedComponent.prototype.ngOnInit = function () { };
    AreaStackedComponent.prototype.ngOnChanges = function (changes) {
        Object.assign(this.options, this.customOptions);
        if ((this.data && (changes["data"].previousValue != changes["data"].currentValue)) ||
            (this.options.isXAxisDate && (changes["customOptions"].previousValue != changes["customOptions"].currentValue))) {
            this.data.forEach(function (element) {
                element.series.forEach(function (seriesData) {
                    seriesData.name = new Date(seriesData.name);
                });
            });
        }
    };
    AreaStackedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return AreaStackedComponent;
}());
AreaStackedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-area-stacked',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-area-chart-stacked\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [timeline]=\"options.timeline\"\n        (select)=\"mSelectedEvent($event)\">\n        <!-- [autoScale]=\"options.autoScale\"\n        [roundDomains]=\"options.roundDomains\"> -->\n    </ngx-charts-area-chart-stacked>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
AreaStackedComponent.ctorParameters = function () { return []; };
AreaStackedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var AreaNormalizedComponent = /** @class */ (function () {
    function AreaNormalizedComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new LineOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    AreaNormalizedComponent.prototype.ngOnInit = function () { };
    AreaNormalizedComponent.prototype.ngOnChanges = function (changes) {
        Object.assign(this.options, this.customOptions);
        if ((this.data && (changes["data"].previousValue != changes["data"].currentValue)) ||
            (this.options.isXAxisDate && (changes["customOptions"].previousValue != changes["customOptions"].currentValue))) {
            this.data.forEach(function (element) {
                element.series.forEach(function (seriesData) {
                    seriesData.name = new Date(seriesData.name);
                });
            });
        }
    };
    AreaNormalizedComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return AreaNormalizedComponent;
}());
AreaNormalizedComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-area-normalized',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-area-chart-normalized\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [timeline]=\"options.timeline\"\n        (select)=\"mSelectedEvent($event)\">\n        <!-- [autoScale]=\"options.autoScale\"\n        [roundDomains]=\"options.roundDomains\"> -->\n    </ngx-charts-area-chart-normalized>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [".chart-container{width:100%;height:100%}"]
            },] },
];
AreaNormalizedComponent.ctorParameters = function () { return []; };
AreaNormalizedComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var MapOptions = /** @class */ (function (_super) {
    __extends(MapOptions, _super);
    function MapOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel, timeline, isXAxisDate, innerPadding, showSkew, colorScheme) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = ''; }
        if (yAxisLabel === void 0) { yAxisLabel = ''; }
        if (timeline === void 0) { timeline = false; }
        if (isXAxisDate === void 0) { isXAxisDate = false; }
        if (innerPadding === void 0) { innerPadding = 5; }
        if (showSkew === void 0) { showSkew = false; }
        if (colorScheme === void 0) { colorScheme = null; }
        var _this = _super.call(this, showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) || this;
        _this.innerPadding = innerPadding;
        _this.showSkew = showSkew;
        _this.colorScheme = colorScheme;
        return _this;
    }
    return MapOptions;
}(BarOptions));
var HeatComponent = /** @class */ (function () {
    function HeatComponent() {
        this.onSelect = new core.EventEmitter();
        this.options = new MapOptions();
    }
    HeatComponent.prototype.ngOnInit = function () { };
    HeatComponent.prototype.ngOnChanges = function (changes) {
        Object.assign(this.options, this.customOptions);
        if (this.options.colorScheme != null) {
            this.colorScheme = {};
            this.colorScheme['domain'] = this.options.colorScheme;
        }
        else {
            this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
        }
        if (this.options.showSkew && (changes["customOptions"].previousValue != changes["customOptions"].currentValue)) {
            this.data.sort(function (current, next) {
                if (current.series.length > next.series.length) {
                    return -1;
                }
                else if (current.series.length < next.series.length) {
                    return 1;
                }
                return 0;
            });
        }
    };
    HeatComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return HeatComponent;
}());
HeatComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-heat',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-heat-map\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [gradient]=\"gradient\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [innerPadding]=\"options.innerPadding\"\n        (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-heat-map>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [""]
            },] },
];
HeatComponent.ctorParameters = function () { return []; };
HeatComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var TreeComponent = /** @class */ (function () {
    function TreeComponent() {
        this.onSelect = new core.EventEmitter();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    TreeComponent.prototype.ngOnInit = function () { };
    TreeComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return TreeComponent;
}());
TreeComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-tree',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-tree-map\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-tree-map>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [""]
            },] },
];
TreeComponent.ctorParameters = function () { return []; };
TreeComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "onSelect": [{ type: core.Output },],
};
var BarLineComboOptions = /** @class */ (function (_super) {
    __extends(BarLineComboOptions, _super);
    function BarLineComboOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = ''; }
        if (yAxisLabel === void 0) { yAxisLabel = ''; }
        var _this = _super.call(this, showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) || this;
        _this.showRightYAxisLabel = false;
        return _this;
    }
    return BarLineComboOptions;
}(BarOptions));
var BarLineWrapperComponent = /** @class */ (function () {
    function BarLineWrapperComponent() {
        this.dataBar = [];
        this.dataLine = [];
        this.onSelect = new core.EventEmitter();
        this.options = new BarLineComboOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BarLineWrapperComponent.prototype.ngOnInit = function () {
        console.log(this.dataBar, this.dataLine);
        Object.assign(this.options, this.customOptions);
    };
    BarLineWrapperComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    BarLineWrapperComponent.prototype.yLeftAxisScale = function (min, max) {
        return { min: "" + min, max: "" + max };
    };
    BarLineWrapperComponent.prototype.yRightAxisScale = function (min, max) {
        return { min: "" + min, max: "" + max };
    };
    BarLineWrapperComponent.prototype.yLeftTickFormat = function (data) {
        return "" + data.toLocaleString();
    };
    BarLineWrapperComponent.prototype.yRightTickFormat = function (data) {
        return data + "%";
    };
    return BarLineWrapperComponent;
}());
BarLineWrapperComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-combo-bar-line',
                template: "\n<div class=\"chart-container\" *ngIf=\"(dataBar && (dataBar.length > 0)) && (dataLine && (dataLine.length > 0))\">\n    <neu-charts-combo-bar-line-raw\n        [scheme]=\"colorScheme\"\n        [colorSchemeLine]=\"lineChartScheme\"\n        [results]=\"dataBar\"\n        [lineChart]=\"dataLine\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [showRightYAxisLabel]=\"options.showRightYAxisLabel\"\n        [yAxisLabelRight]=\"options.yAxisLabelRight\"\n        [yLeftAxisScaleFactor]=\"yLeftAxisScale\"\n        [yRightAxisScaleFactor]=\"yRightAxisScale\"\n        [yAxisTickFormatting]=\"yLeftTickFormat\"\n        [yRightAxisTickFormatting]=\"yRightTickFormat\"\n        (select)=\"mSelectedEvent($event)\">\n        </neu-charts-combo-bar-line-raw>\n</div>\n<no-data *ngIf=\"(!dataBar) || (dataBar.length <= 0) || (!dataLine) || (dataLine.length <= 0)\"></no-data>"
            },] },
];
BarLineWrapperComponent.ctorParameters = function () { return []; };
BarLineWrapperComponent.propDecorators = {
    "dataBar": [{ type: core.Input, args: ['dataBar',] },],
    "dataLine": [{ type: core.Input, args: ['dataLine',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var BarLineComponent = /** @class */ (function (_super) {
    __extends(BarLineComponent, _super);
    function BarLineComponent() {
        var _this = _super.apply(this, __spread(arguments)) || this;
        _this.curve = d3Shape.curveLinear;
        _this.legend = false;
        _this.legendTitle = 'Legend';
        _this.tooltipDisabled = false;
        _this.showGridLines = true;
        _this.activeEntries = [];
        _this.schemeType = 'ordinal';
        _this.roundDomains = false;
        _this.animations = true;
        _this.activate = new core.EventEmitter();
        _this.deactivate = new core.EventEmitter();
        _this.margin = [10, 20, 10, 20];
        _this.xAxisHeight = 0;
        _this.yAxisWidth = 0;
        _this.scaleType = 'linear';
        _this.yOrientLeft = 'left';
        _this.yOrientRight = 'right';
        _this.legendSpacing = 0;
        _this.barPadding = 8;
        return _this;
    }
    BarLineComponent.prototype.trackBy = function (index, item) {
        return item.name;
    };
    BarLineComponent.prototype.update = function () {
        _super.prototype.update.call(this);
        this.dims = ngxCharts.calculateViewDimensions({
            width: this.width,
            height: this.height,
            margins: this.margin,
            showXAxis: this.xAxis,
            showYAxis: this.yAxis,
            xAxisHeight: this.xAxisHeight,
            yAxisWidth: this.yAxisWidth,
            showXLabel: this.showXAxisLabel,
            showYLabel: this.showYAxisLabel,
            showLegend: this.legend,
            legendType: this.schemeType
        });
        if (!this.yAxis) {
            this.legendSpacing = 0;
        }
        else if (this.showYAxisLabel && this.yAxis) {
            this.legendSpacing = 100;
        }
        else {
            this.legendSpacing = 40;
        }
        this.xScale = this.getXScale();
        this.yScale = this.getYScale();
        this.xDomainLine = this.getXDomainLine();
        if (this.filteredDomain) {
            this.xDomainLine = this.filteredDomain;
        }
        this.yDomainLine = this.getYDomainLine();
        this.seriesDomain = this.getSeriesDomain();
        this.xScaleLine = this.getXScaleLine(this.xDomainLine, this.dims.width);
        this.yScaleLine = this.getYScaleLine(this.yDomainLine, this.dims.height);
        this.setColors();
        this.legendOptions = this.getLegendOptions();
        this.transform = "translate(" + this.dims.xOffset + " , " + this.margin[0] + ")";
    };
    BarLineComponent.prototype.deactivateAll = function () {
        this.activeEntries = __spread(this.activeEntries);
        try {
            for (var _a = __values(this.activeEntries), _b = _a.next(); !_b.done; _b = _a.next()) {
                var entry = _b.value;
                this.deactivate.emit({ value: entry, entries: [] });
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.activeEntries = [];
        var e_1, _c;
    };
    BarLineComponent.prototype.hideCircles = function () {
        this.hoveredVertical = null;
        this.deactivateAll();
    };
    BarLineComponent.prototype.updateHoveredVertical = function (item) {
        this.hoveredVertical = item.value;
        this.deactivateAll();
    };
    BarLineComponent.prototype.updateDomain = function (domain) {
        this.filteredDomain = domain;
        this.xDomainLine = this.filteredDomain;
        this.xScaleLine = this.getXScaleLine(this.xDomainLine, this.dims.width);
    };
    BarLineComponent.prototype.getSeriesDomain = function () {
        this.combinedSeries = this.lineChart.slice(0);
        this.combinedSeries.push({
            name: this.yAxisLabel,
            series: this.results
        });
        return this.combinedSeries.map(function (d) { return d.name; });
    };
    BarLineComponent.prototype.isDate = function (value) {
        if (value instanceof Date) {
            return true;
        }
        return false;
    };
    BarLineComponent.prototype.getScaleType = function (values) {
        var date = true;
        var num = true;
        try {
            for (var values_1 = __values(values), values_1_1 = values_1.next(); !values_1_1.done; values_1_1 = values_1.next()) {
                var value = values_1_1.value;
                if (!this.isDate(value)) {
                    date = false;
                }
                if (typeof value !== 'number') {
                    num = false;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (values_1_1 && !values_1_1.done && (_a = values_1.return)) _a.call(values_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        if (date)
            return 'time';
        if (num)
            return 'linear';
        return 'ordinal';
        var e_2, _a;
    };
    BarLineComponent.prototype.getXDomainLine = function () {
        var values = [];
        try {
            for (var _a = __values(this.lineChart), _b = _a.next(); !_b.done; _b = _a.next()) {
                var results = _b.value;
                try {
                    for (var _c = __values(results.series), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var d = _d.value;
                        if (values.indexOf(d.name) == -1) {
                            values.push(d.name);
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.scaleType = this.getScaleType(values);
        var domain = [];
        if (this.scaleType === 'time') {
            var min = Math.min.apply(Math, __spread(values));
            var max = Math.max.apply(Math, __spread(values));
            domain = [min, max];
        }
        else if (this.scaleType === 'linear') {
            values = values.map(function (v) { return Number(v); });
            var min = Math.min.apply(Math, __spread(values));
            var max = Math.max.apply(Math, __spread(values));
            domain = [min, max];
        }
        else {
            domain = values;
        }
        this.xSet = values;
        return domain;
        var e_4, _f, e_3, _e;
    };
    BarLineComponent.prototype.getYDomainLine = function () {
        var domain = [];
        try {
            for (var _a = __values(this.lineChart), _b = _a.next(); !_b.done; _b = _a.next()) {
                var results = _b.value;
                try {
                    for (var _c = __values(results.series), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var d = _d.value;
                        if (domain.indexOf(d.value) < 0) {
                            domain.push(d.value);
                        }
                        if (d.min !== undefined) {
                            if (domain.indexOf(d.min) < 0) {
                                domain.push(d.min);
                            }
                        }
                        if (d.max !== undefined) {
                            if (domain.indexOf(d.max) < 0) {
                                domain.push(d.max);
                            }
                        }
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_6) throw e_6.error; }
        }
        var min = Math.min.apply(Math, __spread(domain));
        var max = Math.max.apply(Math, __spread(domain));
        if (this.yRightAxisScaleFactor) {
            var minMax = this.yRightAxisScaleFactor(min, max);
            return [Math.min(0, minMax.min), minMax.max];
        }
        else {
            min = Math.min(0, min);
            return [min, max];
        }
        var e_6, _f, e_5, _e;
    };
    BarLineComponent.prototype.getXScaleLine = function (domain, width) {
        var scale;
        if (this.bandwidth === undefined) {
            this.bandwidth = (this.dims.width - this.barPadding);
        }
        if (this.scaleType === 'time') {
            scale = d3Scale.scaleTime()
                .range([0, width])
                .domain(domain);
        }
        else if (this.scaleType === 'linear') {
            scale = d3Scale.scaleLinear()
                .range([0, width])
                .domain(domain);
            if (this.roundDomains) {
                scale = scale.nice();
            }
        }
        else if (this.scaleType === 'ordinal') {
            scale = d3Scale.scalePoint()
                .range([this.bandwidth / 2, width - this.bandwidth / 2])
                .domain(domain);
        }
        return scale;
    };
    BarLineComponent.prototype.getYScaleLine = function (domain, height) {
        var scale = d3Scale.scaleLinear()
            .range([height, 0])
            .domain(domain);
        return this.roundDomains ? scale.nice() : scale;
    };
    BarLineComponent.prototype.getXScale = function () {
        this.xDomain = this.getXDomain();
        var spacing = this.xDomain.length / (this.dims.width / this.barPadding + 1);
        return d3Scale.scaleBand()
            .rangeRound([0, this.dims.width])
            .paddingInner(spacing)
            .domain(this.xDomain);
    };
    BarLineComponent.prototype.getYScale = function () {
        this.yDomain = this.getYDomain();
        var scale = d3Scale.scaleLinear()
            .range([this.dims.height, 0])
            .domain(this.yDomain);
        return this.roundDomains ? scale.nice() : scale;
    };
    BarLineComponent.prototype.getXDomain = function () {
        return this.results.map(function (d) { return d.name; });
    };
    BarLineComponent.prototype.getYDomain = function () {
        var values = this.results.map(function (d) { return d.value; });
        var min = Math.min.apply(Math, __spread([0], values));
        var max = Math.max.apply(Math, __spread(values));
        if (this.yLeftAxisScaleFactor) {
            var minMax = this.yLeftAxisScaleFactor(min, max);
            return [Math.min(0, minMax.min), minMax.max];
        }
        else {
            return [min, max];
        }
    };
    BarLineComponent.prototype.onClick = function (data) {
        this.select.emit(data);
    };
    BarLineComponent.prototype.setColors = function () {
        var domain;
        if (this.schemeType === 'ordinal') {
            domain = this.xDomain;
        }
        else {
            domain = this.yDomain;
        }
        this.customColors = this.scheme;
        this.colorSchemeLine = this.scheme;
        console.log(this.scheme, this.schemeType, domain, this.customColors, this.colorSchemeLine);
        this.colors = new ngxCharts.ColorHelper(this.scheme, this.schemeType, domain, this.customColors);
        this.colorsLine = new ngxCharts.ColorHelper(this.colorSchemeLine, this.schemeType, domain, this.customColors);
    };
    BarLineComponent.prototype.getLegendOptions = function () {
        var opts = {
            scaleType: this.schemeType,
            colors: undefined,
            domain: [],
            title: undefined
        };
        if (opts.scaleType === 'ordinal') {
            opts.domain = this.seriesDomain;
            opts.colors = this.colorsLine;
            opts.title = this.legendTitle;
        }
        else {
            opts.domain = this.seriesDomain;
            opts.colors = this.colors.scale;
        }
        return opts;
    };
    BarLineComponent.prototype.updateLineWidth = function (width) {
        this.bandwidth = width;
    };
    BarLineComponent.prototype.updateYAxisWidth = function (_a) {
        var width = _a.width;
        this.yAxisWidth = width + 20;
        this.update();
    };
    BarLineComponent.prototype.updateXAxisHeight = function (_a) {
        var height = _a.height;
        this.xAxisHeight = height;
        this.update();
    };
    BarLineComponent.prototype.onActivate = function (item) {
        var idx = this.activeEntries.findIndex(function (d) {
            return d.name === item.name && d.value === item.value && d.series === item.series;
        });
        if (idx > -1) {
            return;
        }
        this.activeEntries = __spread([item], this.activeEntries);
        this.activate.emit({ value: item, entries: this.activeEntries });
    };
    BarLineComponent.prototype.onDeactivate = function (item) {
        var idx = this.activeEntries.findIndex(function (d) {
            return d.name === item.name && d.value === item.value && d.series === item.series;
        });
        this.activeEntries.splice(idx, 1);
        this.activeEntries = __spread(this.activeEntries);
        this.deactivate.emit({ value: item, entries: this.activeEntries });
    };
    return BarLineComponent;
}(ngxCharts.BaseChartComponent));
BarLineComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-combo-bar-line-raw',
                template: "\n      <ngx-charts-chart\n        [view]=\"[width + legendSpacing, height]\"\n        [showLegend]=\"legend\"\n        [legendOptions]=\"legendOptions\"\n        [activeEntries]=\"activeEntries\"\n        [animations]=\"animations\"\n        (legendLabelClick)=\"onClick($event)\"\n        (legendLabelActivate)=\"onActivate($event)\"\n        (legendLabelDeactivate)=\"onDeactivate($event)\">\n        <svg:g [attr.transform]=\"transform\" class=\"bar-chart chart\">\n            <svg:g ngx-charts-x-axis\n            *ngIf=\"xAxis\"\n            [xScale]=\"xScale\"\n            [dims]=\"dims\"\n            [showLabel]=\"showXAxisLabel\"\n            [labelText]=\"xAxisLabel\"\n            [tickFormatting]=\"xAxisTickFormatting\"\n            (dimensionsChanged)=\"updateXAxisHeight($event)\">\n          </svg:g>\n          <svg:g ngx-charts-y-axis\n            *ngIf=\"yAxis\"\n            [yScale]=\"yScale\"\n            [dims]=\"dims\"\n            [yOrient]=\"yOrientLeft\"\n            [showGridLines]=\"showGridLines\"\n            [showLabel]=\"showYAxisLabel\"\n            [labelText]=\"yAxisLabel\"\n            [tickFormatting]=\"yAxisTickFormatting\"\n            (dimensionsChanged)=\"updateYAxisWidth($event)\">\n          </svg:g>\n          <svg:g ngx-charts-y-axis\n            *ngIf=\"yAxis\"\n            [yScale]=\"yScaleLine\"\n            [dims]=\"dims\"\n            [yOrient]=\"yOrientRight\"\n            [showGridLines]=\"showGridLines\"\n            [showLabel]=\"showRightYAxisLabel\"\n            [labelText]=\"yAxisLabelRight\"\n            [tickFormatting]=\"yRightAxisTickFormatting\"\n            (dimensionsChanged)=\"updateYAxisWidth($event)\">\n          </svg:g>\n          <svg:g ngx-combo-charts-series-vertical\n            [xScale]=\"xScale\"\n            [yScale]=\"yScale\"\n            [colors]=\"colors\"\n            [series]=\"results\"\n            [seriesLine]=\"lineChart\"\n            [dims]=\"dims\"\n            [gradient]=\"gradient\"\n            tooltipDisabled=\"true\"\n            [activeEntries]=\"activeEntries\"\n            [animations]=\"animations\"\n            (activate)=\"onActivate($event)\"\n            (deactivate)=\"onDeactivate($event)\"\n            (bandwidth)=\"updateLineWidth($event)\"\n            (select)=\"onClick($event)\">\n          </svg:g>\n        </svg:g>\n        <svg:g [attr.transform]=\"transform\" class=\"line-chart chart\">\n          <svg:g [attr.clip-path]=\"clipPath\">\n            <svg:g *ngFor=\"let series of lineChart; trackBy:trackBy\">\n              <svg:g ngx-charts-line-series\n                [xScale]=\"xScaleLine\"\n                [yScale]=\"yScaleLine\"\n                [colors]=\"colorsLine\"\n                [data]=\"series\"\n                [activeEntries]=\"activeEntries\"\n                [scaleType]=\"scaleType\"\n                [curve]=\"curve\"\n                [rangeFillOpacity]=\"rangeFillOpacity\"\n                [animations]=\"animations\"\n              />\n            </svg:g>\n            <svg:g ngx-charts-tooltip-area\n              *ngIf=\"!tooltipDisabled\"\n              [dims]=\"dims\"\n              [xSet]=\"xSet\"\n              [xScale]=\"xScaleLine\"\n              [yScale]=\"yScaleLine\"\n              [results]=\"combinedSeries\"\n              [colors]=\"colorsLine\"\n              [tooltipDisabled]=\"tooltipDisabled\"\n              (hover)=\"updateHoveredVertical($event)\"\n            />\n            <svg:g *ngFor=\"let series of lineChart\">\n              <svg:g ngx-charts-circle-series\n                [xScale]=\"xScaleLine\"\n                [yScale]=\"yScaleLine\"\n                [colors]=\"colorsLine\"\n                [data]=\"series\"\n                [scaleType]=\"scaleType\"\n                [visibleValue]=\"hoveredVertical\"\n                [activeEntries]=\"activeEntries\"\n                [tooltipDisabled]=\"tooltipDisabled\"\n                (select)=\"onClick($event, series)\"\n                (activate)=\"onActivate($event)\"\n                (deactivate)=\"onDeactivate($event)\"\n              />\n            </svg:g>\n          </svg:g>\n        </svg:g>\n      </ngx-charts-chart>\n    ",
                styles: [".ngx-charts{float:left;overflow:visible}.ngx-charts .arc,.ngx-charts .bar,.ngx-charts .circle{cursor:pointer}.ngx-charts .arc.active,.ngx-charts .arc:hover,.ngx-charts .bar.active,.ngx-charts .bar:hover,.ngx-charts .card.active,.ngx-charts .card:hover,.ngx-charts .cell.active,.ngx-charts .cell:hover{opacity:.8;-webkit-transition:opacity .1s ease-in-out;transition:opacity .1s ease-in-out}.ngx-charts .arc:focus,.ngx-charts .bar:focus,.ngx-charts .card:focus,.ngx-charts .cell:focus,.ngx-charts g:focus{outline:0}.ngx-charts .area-series.inactive,.ngx-charts .line-series-range.inactive,.ngx-charts .line-series.inactive{-webkit-transition:opacity .1s ease-in-out;transition:opacity .1s ease-in-out;opacity:.2}.ngx-charts .line-highlight{display:none}.ngx-charts .line-highlight.active{display:block}.ngx-charts .area{opacity:.6}.ngx-charts .circle:hover{cursor:pointer}.ngx-charts .label{font-size:12px;font-weight:400}.ngx-charts .tooltip-anchor{fill:#000}.ngx-charts .gridline-path{stroke:#ddd;stroke-width:1;fill:none}.ngx-charts .grid-panel rect{fill:none}.ngx-charts .grid-panel.odd rect{fill:rgba(0,0,0,.05)}"],
                encapsulation: core.ViewEncapsulation.None
            },] },
];
BarLineComponent.ctorParameters = function () { return []; };
BarLineComponent.propDecorators = {
    "lineSeriesComponent": [{ type: core.ViewChild, args: [ngxCharts.LineSeriesComponent,] },],
    "curve": [{ type: core.Input },],
    "legend": [{ type: core.Input },],
    "legendTitle": [{ type: core.Input },],
    "xAxis": [{ type: core.Input },],
    "yAxis": [{ type: core.Input },],
    "showXAxisLabel": [{ type: core.Input },],
    "showYAxisLabel": [{ type: core.Input },],
    "showRightYAxisLabel": [{ type: core.Input },],
    "xAxisLabel": [{ type: core.Input },],
    "yAxisLabel": [{ type: core.Input },],
    "yAxisLabelRight": [{ type: core.Input },],
    "tooltipDisabled": [{ type: core.Input },],
    "gradient": [{ type: core.Input },],
    "showGridLines": [{ type: core.Input },],
    "activeEntries": [{ type: core.Input },],
    "schemeType": [{ type: core.Input },],
    "xAxisTickFormatting": [{ type: core.Input },],
    "yAxisTickFormatting": [{ type: core.Input },],
    "yRightAxisTickFormatting": [{ type: core.Input },],
    "roundDomains": [{ type: core.Input },],
    "colorSchemeLine": [{ type: core.Input },],
    "autoScale": [{ type: core.Input },],
    "lineChart": [{ type: core.Input },],
    "yLeftAxisScaleFactor": [{ type: core.Input },],
    "yRightAxisScaleFactor": [{ type: core.Input },],
    "rangeFillOpacity": [{ type: core.Input },],
    "animations": [{ type: core.Input },],
    "activate": [{ type: core.Output },],
    "deactivate": [{ type: core.Output },],
    "tooltipTemplate": [{ type: core.ContentChild, args: ['tooltipTemplate',] },],
    "seriesTooltipTemplate": [{ type: core.ContentChild, args: ['seriesTooltipTemplate',] },],
    "hideCircles": [{ type: core.HostListener, args: ['mouseleave',] },],
};
var BarSeriesComboComponent = /** @class */ (function () {
    function BarSeriesComboComponent() {
        this.type = 'standard';
        this.tooltipDisabled = false;
        this.animations = true;
        this.select = new core.EventEmitter();
        this.activate = new core.EventEmitter();
        this.deactivate = new core.EventEmitter();
        this.bandwidth = new core.EventEmitter();
    }
    BarSeriesComboComponent.prototype.ngOnChanges = function (changes) {
        this.update();
    };
    BarSeriesComboComponent.prototype.update = function () {
        var _this = this;
        var width;
        if (this.series.length) {
            width = this.xScale.bandwidth();
            this.bandwidth.emit(width);
        }
        var d0 = 0;
        var total;
        if (this.type === 'normalized') {
            total = this.series.map(function (d) { return d.value; }).reduce(function (sum, d) { return sum + d; }, 0);
        }
        this.bars = this.series.map(function (d, index) {
            var value = d.value;
            var label = d.name;
            var formattedLabel = ngxCharts.formatLabel(label);
            var roundEdges = _this.type === 'standard';
            var bar = {
                value: value,
                label: label,
                roundEdges: roundEdges,
                data: d,
                width: width,
                formattedLabel: formattedLabel,
                height: 0,
                x: 0,
                y: 0
            };
            if (_this.type === 'standard') {
                bar.height = Math.abs(_this.yScale(value) - _this.yScale(0));
                bar.x = _this.xScale(label);
                if (value < 0) {
                    bar.y = _this.yScale(0);
                }
                else {
                    bar.y = _this.yScale(value);
                }
            }
            else if (_this.type === 'stacked') {
                var offset0 = d0;
                var offset1 = offset0 + value;
                d0 += value;
                bar.height = _this.yScale(offset0) - _this.yScale(offset1);
                bar.x = 0;
                bar.y = _this.yScale(offset1);
                bar.offset0 = offset0;
                bar.offset1 = offset1;
            }
            else if (_this.type === 'normalized') {
                var offset0 = d0;
                var offset1 = offset0 + value;
                d0 += value;
                if (total > 0) {
                    offset0 = (offset0 * 100) / total;
                    offset1 = (offset1 * 100) / total;
                }
                else {
                    offset0 = 0;
                    offset1 = 0;
                }
                bar.height = _this.yScale(offset0) - _this.yScale(offset1);
                bar.x = 0;
                bar.y = _this.yScale(offset1);
                bar.offset0 = offset0;
                bar.offset1 = offset1;
                value = (offset1 - offset0).toFixed(2) + '%';
            }
            if (_this.colors.scaleType === 'ordinal') {
                bar.color = _this.colors.getColor(label);
            }
            else {
                if (_this.type === 'standard') {
                    bar.color = _this.colors.getColor(value);
                    bar.gradientStops = _this.colors.getLinearGradientStops(value);
                }
                else {
                    bar.color = _this.colors.getColor(bar.offset1);
                    bar.gradientStops = _this.colors.getLinearGradientStops(bar.offset1, bar.offset0);
                }
            }
            var tooltipLabel = formattedLabel;
            if (_this.seriesName) {
                tooltipLabel = _this.seriesName + " \u2022 " + formattedLabel;
            }
            _this.getSeriesTooltips(_this.seriesLine, index);
            var line = _this.seriesLine[0].series[index];
            if ((_this.seriesLine.length >= index) && (line)) {
                var lineValue = line.value;
                var lineName = line.name;
                bar.tooltipText = "\n                <span class=\"tooltip-label\">" + tooltipLabel + "</span>\n                <span class=\"tooltip-val\"> Y1 - " + value.toLocaleString() + " \u2022 Y2 - " + lineValue.toLocaleString() + "%</span>\n                ";
            }
            return bar;
        });
    };
    BarSeriesComboComponent.prototype.getSeriesTooltips = function (seriesLine, index) {
        return seriesLine.map(function (d) {
            return d.series[index];
        });
    };
    BarSeriesComboComponent.prototype.isActive = function (entry) {
        if (!this.activeEntries)
            return false;
        var item = this.activeEntries.find(function (d) {
            return entry.name === d.name && entry.series === d.series;
        });
        return item !== undefined;
    };
    BarSeriesComboComponent.prototype.onClick = function (data) {
        this.select.emit(data);
    };
    BarSeriesComboComponent.prototype.trackBy = function (index, bar) {
        return bar.label;
    };
    return BarSeriesComboComponent;
}());
BarSeriesComboComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'g[ngx-combo-charts-series-vertical]',
                template: "\n      <svg:g ngx-charts-bar *ngFor=\"let bar of bars; trackBy: trackBy\"\n        [@animationState]=\"'active'\"\n        [width]=\"bar.width\"\n        [height]=\"bar.height\"\n        [x]=\"bar.x\"\n        [y]=\"bar.y\"\n        [fill]=\"bar.color\"\n        [stops]=\"bar.gradientStops\"\n        [data]=\"bar.data\"\n        [orientation]=\"'vertical'\"\n        [roundEdges]=\"bar.roundEdges\"\n        [gradient]=\"gradient\"\n        [isActive]=\"isActive(bar.data)\"\n        [animations]=\"animations\"\n        (select)=\"onClick($event)\"\n        (activate)=\"activate.emit($event)\"\n        (deactivate)=\"deactivate.emit($event)\"\n        ngx-tooltip\n        [tooltipDisabled]=\"tooltipDisabled\"\n        [tooltipPlacement]=\"'top'\"\n        [tooltipType]=\"'tooltip'\"\n        [tooltipTitle]=\"bar.tooltipText\">\n      </svg:g>\n    ",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                animations: [
                    animations.trigger('animationState', [
                        animations.transition('* => void', [
                            animations.style({
                                opacity: 1,
                                transform: '*',
                            }),
                            animations.animate(500, animations.style({ opacity: 0, transform: 'scale(0)' }))
                        ])
                    ])
                ]
            },] },
];
BarSeriesComboComponent.ctorParameters = function () { return []; };
BarSeriesComboComponent.propDecorators = {
    "dims": [{ type: core.Input },],
    "type": [{ type: core.Input },],
    "series": [{ type: core.Input },],
    "seriesLine": [{ type: core.Input },],
    "xScale": [{ type: core.Input },],
    "yScale": [{ type: core.Input },],
    "colors": [{ type: core.Input },],
    "tooltipDisabled": [{ type: core.Input },],
    "gradient": [{ type: core.Input },],
    "activeEntries": [{ type: core.Input },],
    "seriesName": [{ type: core.Input },],
    "animations": [{ type: core.Input },],
    "select": [{ type: core.Output },],
    "activate": [{ type: core.Output },],
    "deactivate": [{ type: core.Output },],
    "bandwidth": [{ type: core.Output },],
};
var BubbleOptions = /** @class */ (function (_super) {
    __extends(BubbleOptions, _super);
    function BubbleOptions(showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel, autoScale, xScaleMin, xScaleMax, yScaleMin, yScaleMax, roundDomains, minRadius, maxRadius, view) {
        if (showLegend === void 0) { showLegend = true; }
        if (showXAxis === void 0) { showXAxis = true; }
        if (showYAxis === void 0) { showYAxis = true; }
        if (showXAxisLabel === void 0) { showXAxisLabel = true; }
        if (showYAxisLabel === void 0) { showYAxisLabel = true; }
        if (xAxisLabel === void 0) { xAxisLabel = 'x'; }
        if (yAxisLabel === void 0) { yAxisLabel = 'y'; }
        if (autoScale === void 0) { autoScale = true; }
        if (xScaleMin === void 0) { xScaleMin = 0; }
        if (xScaleMax === void 0) { xScaleMax = 20; }
        if (yScaleMin === void 0) { yScaleMin = 0; }
        if (yScaleMax === void 0) { yScaleMax = 0; }
        if (roundDomains === void 0) { roundDomains = true; }
        if (minRadius === void 0) { minRadius = 4; }
        if (maxRadius === void 0) { maxRadius = 15; }
        if (view === void 0) { view = undefined; }
        var _this = _super.call(this, showLegend, showXAxis, showYAxis, showXAxisLabel, showYAxisLabel, xAxisLabel, yAxisLabel) || this;
        _this.view = view;
        _this.autoScale = autoScale;
        _this.xScaleMin = xScaleMin;
        _this.xScaleMax = xScaleMax;
        _this.yScaleMin = yScaleMin;
        _this.yScaleMax = yScaleMax;
        _this.roundDomains = roundDomains;
        _this.minRadius = minRadius;
        _this.maxRadius = maxRadius;
        return _this;
    }
    return BubbleOptions;
}(BarOptions));
var BubbleComponent = /** @class */ (function () {
    function BubbleComponent() {
        this.data = [];
        this.onSelect = new core.EventEmitter();
        this.options = new BubbleOptions();
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    BubbleComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
        console.log("bub option", this.options);
    };
    BubbleComponent.prototype.mSelectedEvent = function (event) {
        this.onSelect.emit(event);
    };
    return BubbleComponent;
}());
BubbleComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-charts-bubble',
                template: "<div class=\"chart-container\" *ngIf=\"data && (data.length > 0)\">\n    <ngx-charts-bubble-chart\n        [view]=\"options.view\"\n        [scheme]=\"colorScheme\"\n        [results]=\"data\"\n        [legend]=\"options.showLegend\"\n        [xAxis]=\"options.showXAxis\"\n        [yAxis]=\"options.showYAxis\"\n        [showXAxisLabel]=\"options.showXAxisLabel\"\n        [showYAxisLabel]=\"options.showYAxisLabel\"\n        [xAxisLabel]=\"options.xAxisLabel\"\n        [yAxisLabel]=\"options.yAxisLabel\"\n        [autoScale]=\"options.autoScale\"\n        [roundDomains]=\"options.roundDomains\"\n        [minRadius]=\"options.minRadius\"\n        [maxRadius]=\"options.maxRadius\"\n        (select)=\"mSelectedEvent($event)\">\n    </ngx-charts-bubble-chart>\n</div>\n<no-data *ngIf=\"(!data) || (data.length <= 0)\"></no-data>",
                styles: [""]
            },] },
];
BubbleComponent.ctorParameters = function () { return []; };
BubbleComponent.propDecorators = {
    "data": [{ type: core.Input, args: ['data',] },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
    "onSelect": [{ type: core.Output },],
};
var DirectedGraph = /** @class */ (function () {
    function DirectedGraph(view, showLegend, orientation, autoCenter, autoZoom) {
        if (view === void 0) { view = []; }
        if (showLegend === void 0) { showLegend = false; }
        if (orientation === void 0) { orientation = 'TB'; }
        if (autoCenter === void 0) { autoCenter = true; }
        if (autoZoom === void 0) { autoZoom = true; }
        this.view = view;
        this.showLegend = showLegend;
        this.orientation = orientation;
        this.autoCenter = autoCenter;
        this.autoZoom = autoZoom;
    }
    return DirectedGraph;
}());
var DirectedGraphComponent = /** @class */ (function () {
    function DirectedGraphComponent() {
        this.options = new DirectedGraph;
        this.curve = d3Shape.curveBundle;
        this.colorScheme = customColorSets.find(function (s) { return s.name == 'palatte'; });
    }
    DirectedGraphComponent.prototype.ngOnInit = function () {
        Object.assign(this.options, this.customOptions);
    };
    DirectedGraphComponent.prototype.mOnSelect = function (event) {
        console.log('clicked', event);
    };
    return DirectedGraphComponent;
}());
DirectedGraphComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'neu-directed-graph',
                template: "<div *ngIf=\"data && data['links'] && data['nodes']\" class=\"chart-container\">\n    <ngx-graph class=\"chart-container\"\n        [links]=\"data['links']\"\n        [nodes]=\"data['nodes']\"\n        [scheme]=\"colorScheme\"\n        [view]=\"options.view\"\n        [legend]=\"options.showLegend\"\n        [orientation]=\"options.orientation\"\n        [curve]=\"curve\"\n        [autoCenter]=\"options.autoCenter\"\n        [autoZoom]=\"options.autoZoom\"\n        (select)=\"mOnSelect($event)\">\n        <ng-template #defsTemplate>\n            <svg:marker id=\"arrow\" viewBox=\"0 -5 10 10\" refX=\"8\" refY=\"0\" markerWidth=\"4\" markerHeight=\"4\" orient=\"auto\">\n                <svg:path d=\"M0,-5L10,0L0,5\" class=\"arrow-head\" />\n            </svg:marker>\n        </ng-template>\n        <ng-template #nodeTemplate let-node>\n            <svg:g class=\"node\">\n                <!-- ngx-tooltip [tooltipPlacement]=\"'top'\" [tooltipType]=\"'tooltip'\" [tooltipTitle]=\"node.label\"> -->\n                <svg:rect [attr.width]=\"node.width\" [attr.height]=\"node.height\" [attr.fill]=\"node.options.color\" />\n                <svg:text alignment-baseline=\"central\" [attr.x]=\"10\" [attr.y]=\"node.height / 2\">{{node.label}}</svg:text>\n            </svg:g>\n        </ng-template>\n        <ng-template #linkTemplate let-link>\n            <svg:g class=\"edge\">\n                <svg:path\n                    class=\"line\"\n                    stroke-width=\"2\"\n                    marker-end=\"url(#arrow)\">\n                </svg:path>\n                <svg:text class=\"edge-label\" text-anchor=\"middle\">\n                    <textPath class=\"text-path\"\n                        style=\"fill: #666;\"\n                        [attr.href]=\"'#' + link.id\"\n                        [style.dominant-baseline]=\"link.dominantBaseline\"\n                        startOffset=\"50%\">\n                        {{link.label}}\n                    </textPath>\n                </svg:text>\n            </svg:g>\n        </ng-template>\n    </ngx-graph>\n</div>\n<no-data *ngIf=\"(!data) || (!data['links']) || (!data['nodes'])\"></no-data>",
                styles: [""]
            },] },
];
DirectedGraphComponent.ctorParameters = function () { return []; };
DirectedGraphComponent.propDecorators = {
    "data": [{ type: core.Input },],
    "customOptions": [{ type: core.Input, args: ['options',] },],
};
var PIECOMPONENTS = [PieChartComponent, DonutChartComponent, DonutAdvancedComponent, DonutGridComponent];
var BARCOMPONENTS = [BarVerticalComponent, BarHorizontalComponent, BarVerticalGroupedComponent, BarHorizontalGroupedComponent,
    BarHorizontalStackedComponent, BarVerticalStackedComponent, BarVerticalNormalizedComponent, BarHorizontalNormalizedComponent];
var LINEORAREACOMPONENTS = [LineComponent, AreaComponent, AreaStackedComponent, AreaNormalizedComponent];
var MAPCOMPONENTS = [HeatComponent, TreeComponent];
var COMBOCOMPONENT = [BarLineWrapperComponent, BarLineComponent, BarSeriesComboComponent];
var SCATTERCOMPONENT = [BubbleComponent];
var GRAPHCOMPONENT = [DirectedGraphComponent];
var NeuChartsModule = /** @class */ (function () {
    function NeuChartsModule() {
    }
    return NeuChartsModule;
}());
NeuChartsModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ngxCharts.NgxChartsModule,
                    ngxGraph.NgxGraphModule
                ],
                declarations: __spread([NeuChartsComponent, NoDataComponent], PIECOMPONENTS, BARCOMPONENTS, LINEORAREACOMPONENTS, MAPCOMPONENTS, COMBOCOMPONENT, SCATTERCOMPONENT, GRAPHCOMPONENT),
                exports: __spread(PIECOMPONENTS, BARCOMPONENTS, LINEORAREACOMPONENTS, MAPCOMPONENTS, COMBOCOMPONENT, SCATTERCOMPONENT, GRAPHCOMPONENT)
            },] },
];
NeuChartsModule.ctorParameters = function () { return []; };

exports.NeuChartsModule = NeuChartsModule;
exports.ɵj = BarHorizontalGroupedComponent;
exports.ɵn = BarHorizontalNormalizedComponent;
exports.ɵk = BarHorizontalStackedComponent;
exports.ɵh = BarHorizontalComponent;
exports.ɵi = BarVerticalGroupedComponent;
exports.ɵm = BarVerticalNormalizedComponent;
exports.ɵl = BarVerticalStackedComponent;
exports.ɵg = BarVerticalComponent;
exports.ɵu = BarLineWrapperComponent;
exports.ɵv = BarLineComponent;
exports.ɵw = BarSeriesComboComponent;
exports.ɵy = DirectedGraphComponent;
exports.ɵr = AreaNormalizedComponent;
exports.ɵq = AreaStackedComponent;
exports.ɵp = AreaComponent;
exports.ɵo = LineComponent;
exports.ɵs = HeatComponent;
exports.ɵt = TreeComponent;
exports.ɵe = DonutAdvancedComponent;
exports.ɵd = DonutChartComponent;
exports.ɵf = DonutGridComponent;
exports.ɵc = PieChartComponent;
exports.ɵx = BubbleComponent;
exports.ɵa = NeuChartsComponent;
exports.ɵb = NoDataComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=neu-charts.umd.js.map
